# Adapted from Marcus' AICA example among a few other sources =)

.globl	arm_main
.text

# Reset vectors

# Reset
reset:
	b	start
# Undefined instruction
	b	undef
# Software interrupt
	b	undef
# Abort prefetch
	b	undef
# Abort data
	b	undef
# Reserved
	nop
# IRQ
	b	undef
# Fast IRQ
	b	fiq


start:
	# Setup a basic stack, disable all interupts
	mov	sp,#0xb000
	mrs	r10,CPSR
	orr	r10,r10,#0xc0
	msr	CPSR_all,r10

	# Call the main for the SPU
	bl	arm_main

	# Loop infinitely if we get here
here:	b	here


# FIQ code adapted from the Marcus AICA example
fiq:
	# Save regs
	stmdb	sp!, {r0-r14}

	# Grab interrupt type (store as parameter)
	ldr	r8,intreq
	ldr	r0,[r8]
	and	r0,r0,#7

	# Call handler
	bl	fiq_handler

	# Clear interrupt
	ldr	r8,intclr
	mov	r9,#1
	str	r9,[r8]
	str	r9,[r8]
	str	r9,[r8]
	str	r9,[r8]

	# Restore regs and return
	ldmdb	sp!, {r0-r14}
	sub	pc,r14,#4

intreq:
	.long	0x00802d00
intclr:
	.long	0x00802d04


undef:
	b	undef






